#include <common.h>
#include <config.h>
#include <asm/io.h>
#include <asm/tc3162.h>

#include <asm/arch/typedefs.h>
#include <asm/arch/ecnt_timer.h>
#include <asm/arch/en7523.h>

DECLARE_GLOBAL_DATA_PTR;

int dram_init(void)
{
	gd->ram_size = GET_DRAM_SIZE * SZ_1M;

#if defined(CONFIG_MTK_ATF)
	/*It just sync from MT6735m preloader. They will reserve 1MB for ATF log*/
	gd->ram_size -= SZ_16M;
#endif

	return 0;
}

int board_init(void)
{
	ecnt_timer_init();

	gd->bd->bi_boot_params = CONFIG_SYS_SDRAM_BASE + 0x100;

    return 0;
}

int board_late_init (void)
{
	gd->env_valid = 1;
	env_relocate();

	return 0;
}


void ft_board_setup(void *blob, bd_t *bd)
{

}

#ifndef CONFIG_SYS_DCACHE_OFF
void enable_caches(void)
{
	//dcache_enable();
}
#endif

int board_eth_init(bd_t *bis)
{
	ecnt_eth_initialize(bis);
	return 0;
}

